SystemOrganization addCategory: #'Xpf-Multipoint-Plugin'!

Object subclass: #MultiPointer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

MultiPointer class
	instanceVariableNames: 'eventSemaphore deviceSemaphore'!

MultiPointer class
	instanceVariableNames: 'eventSemaphore deviceSemaphore'!

!MultiPointer class methodsFor: 'accessing' stamp: 'SR 4/29/2009 18:58'!
deviceSemaphore

	deviceSemaphore ifNil: [self deviceSemaphore: Semaphore new].
	^ deviceSemaphore! !

!MultiPointer class methodsFor: 'accessing' stamp: 'SR 4/29/2009 18:58'!
deviceSemaphore: anObject

	deviceSemaphore := anObject! !

!MultiPointer class methodsFor: 'accessing' stamp: 'SR 4/29/2009 19:08'!
eventSemaphore

	eventSemaphore ifNil: [self eventSemaphore: Semaphore new].
	^ eventSemaphore! !

!MultiPointer class methodsFor: 'accessing' stamp: 'SR 4/29/2009 18:56'!
eventSemaphore: anObject

	eventSemaphore := anObject! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/22/2009 14:30'!
getPointerCount

	<primitive: 'primitiveMultiPointerCount' module: 'MultiPointerPlugin'>
	^ 42! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/23/2009 11:56'!
getPointerCurrentPoint: aPointerID

	<primitive: 'primitiveMultiPointerCurrentPoint' module: 'MultiPointerPlugin'>
	^ 42 asPoint! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/29/2009 16:42'!
getPointerCurrentState: aPointerID

	| result |
	result := MultiPointerState new.
	self pvtGetPointerCurrentState: aPointerID with: result.
	^ result! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/29/2009 13:53'!
getPointerLively: aPointerID

	| result |
	result := self pvtGetPointerLively: aPointerID.
	^ result = 0
		ifTrue: [false]
		ifFalse: [true].! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 4/22/2009 17:34'!
getPointerName: aPointerID

	| pointerName |
	pointerName := self pvtGetPointerName: aPointerID.
	^ pointerName truncateTo: (pointerName 
			indexOf: (Character value: 0) 
			startingAt: 0 
			ifAbsent: [pointerName size + 1]) - 1! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/29/2009 16:41'!
pvtGetPointerCurrentState: aPointerID with: aMultiPointerState

	<primitive: 'primitiveMultiPointerCurrentState' module: 'MultiPointerPlugin'>
	^ 42 asPoint! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/29/2009 13:52'!
pvtGetPointerLively: aPointerID

	<primitive: 'primitiveMultiPointerLively' module: 'MultiPointerPlugin'>
	^ 42 asPoint! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 4/22/2009 16:56'!
pvtGetPointerName: aPointerID

	<primitive: 'primitiveMultiPointerName' module: 'MultiPointerPlugin'>
	^ 'Pointing Device'! !

!MultiPointer class methodsFor: 'system startup' stamp: 'SR 4/29/2009 19:00'!
registerSemaphore

	| eventSemaIndex deviceSemaIndex |
	eventSemaIndex := Smalltalk registerExternalObject: self eventSemaphore.
	deviceSemaIndex := Smalltalk registerExternalObject: self deviceSemaphore.
	
	self setPointerEventSemaphoreHandle: eventSemaIndex.
	self setPointerDeviceSemaphoreHandle: deviceSemaIndex.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/29/2009 19:06'!
setPointerDeviceSemaphoreHandle: aSemaIndex

	<primitive: 'primitiveMultiPointerDeviceSemaphoreHandle' module: 'MultiPointerPlugin'>! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/29/2009 19:06'!
setPointerEventSemaphoreHandle: aSemaIndex

	<primitive: 'primitiveMultiPointerEventSemaphoreHandle' module: 'MultiPointerPlugin'>! !

!MultiPointer class methodsFor: 'system startup' stamp: 'SR 4/29/2009 19:02'!
unregisterSemaphore

	self setPointerEventSemaphoreHandle: 0.
	self setPointerDeviceSemaphoreHandle: 0.
	
	Smalltalk unregisterExternalObject: self eventSemaphore.
	Smalltalk unregisterExternalObject: self deviceSemaphore.
	
	self eventSemaphore: nil.
	self deviceSemaphore: nil.
! !

Object subclass: #MultiPointerManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

MultiPointerManager class
	instanceVariableNames: 'handMorphs movementProcess deviceUpdateProcess pauseSystemMouse'!

MultiPointerManager class
	instanceVariableNames: 'handMorphs movementProcess deviceUpdateProcess pauseSystemMouse'!

!MultiPointerManager class methodsFor: 'private' stamp: 'SR 4/29/2009 19:49'!
createHandMorphForMouse: aMouseID

	^ self handMorphs
			detect: [:each | each mouseID = aMouseID]
			ifNone: [ | m |
				m := MultiPointerHandMorph new mouseID: aMouseID.
				self handMorphs add: m.
				World addHand: m.
				MultiPointer getPointerCurrentPoint: m mouseID].! !

!MultiPointerManager class methodsFor: 'private' stamp: 'SR 4/29/2009 19:50'!
destroyHandMorphForMouse: aMouseID

	| m |
	m := self handMorphs detect: [:each | each mouseID = aMouseID] ifNone: [nil].
	m ifNotNil: [
		self handMorphs remove: m.
		World removeHand: m].
			! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/29/2009 18:37'!
deviceUpdateProcess

	^ deviceUpdateProcess! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/29/2009 18:37'!
deviceUpdateProcess: anObject

	deviceUpdateProcess := anObject! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:32'!
handMorphs

	^ handMorphs! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:32'!
handMorphs: anObject

	handMorphs := anObject! !

!MultiPointerManager class methodsFor: 'class initialization' stamp: 'SR 4/29/2009 19:55'!
initialize

	super initialize.
	self handMorphs: OrderedCollection new.
	self pauseSystemMouse: false.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:51'!
movementProcess

	^ movementProcess! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:51'!
movementProcess: anObject

	movementProcess := anObject! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/29/2009 19:54'!
pauseSystemMouse

	^ pauseSystemMouse! !

!MultiPointerManager class methodsFor: 'accessing' stamp: 'SR 4/29/2009 19:54'!
pauseSystemMouse: anObject

	pauseSystemMouse := anObject! !

!MultiPointerManager class methodsFor: 'system startup' stamp: 'SR 4/24/2009 14:30'!
shutDown: aboutToQuit 

	MultiPointer unregisterSemaphore.
	super shutDown: aboutToQuit.! !

!MultiPointerManager class methodsFor: 'process control' stamp: 'mig 4/30/2009 11:57'!
startDeviceDiscovery

	self deviceUpdateProcess: [[
			0 to: MultiPointer getPointerCount - 1 do: [ :each |
				(MultiPointer getPointerLively: each)
					ifTrue: [ self createHandMorphForMouse: each ]
					ifFalse: [ self destroyHandMorphForMouse: each ]].
			MultiPointer deviceSemaphore wait.
		] repeat ] fork.! !

!MultiPointerManager class methodsFor: 'process control' stamp: 'SR 4/29/2009 19:55'!
startMoving

	self pauseSystemMouse: true.
	self movementProcess: [
		[
			MultiPointer eventSemaphore wait.
			self handMorphs do: [:each |
				each enqueueEvent: (MultiPointer getPointerCurrentState: each mouseID)]
		] repeat
	] fork.! !

!MultiPointerManager class methodsFor: 'system startup' stamp: 'SR 4/24/2009 14:30'!
startUp: aboutToQuit 

	MultiPointer registerSemaphore.
	super startUp: aboutToQuit.! !

!MultiPointerManager class methodsFor: 'process control' stamp: 'SR 4/29/2009 18:50'!
stopDeviceDiscovery

	self deviceUpdateProcess terminate.
	1 to: MultiPointer getPointerCount do: [:each |
		self destroyHandMorphForMouse: (each-1)].
! !

!MultiPointerManager class methodsFor: 'process control' stamp: 'SR 4/29/2009 19:55'!
stopMoving

	self movementProcess terminate.
	self pauseSystemMouse: false.
! !

Object subclass: #MultiPointerState
	instanceVariableNames: 'x y buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
buttons

	^ buttons! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
buttons: anObject

	buttons := anObject! !

!MultiPointerState methodsFor: 'printing' stamp: 'SR 4/29/2009 16:50'!
printOn: aStream 
	"The receiver prints on aStream in terms of infix notation."

	x printOn: aStream.
	aStream nextPut: $@.
	y printOn: aStream.
	aStream nextPut: $@.
	buttons printOn: aStream.! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
x

	^ x! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
x: anObject

	x := anObject! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
y

	^ y! !

!MultiPointerState methodsFor: 'accessing' stamp: 'SR 4/24/2009 15:37'!
y: anObject

	y := anObject! !

!HandMorph methodsFor: '*xpf-multipoint-override' stamp: 'SR 4/29/2009 20:09'!
processEvents
	"Process user input events from the local input devices."

	| evt evtBuf type hadAny |
	ActiveEvent ifNotNil: [
		"Meaning that we were invoked from within an event response.
		Make sure z-order is up to date"
		self mouseOverHandler processMouseOver: lastMouseEvent].
	
	hadAny := false.
	[(evtBuf := Sensor nextEvent) isNil] whileFalse: [
		evt := nil.	"for unknown event types"
		type := evtBuf first.
		type = EventTypeMouse
			ifTrue: [
				MultiPointerManager pauseSystemMouse
					ifTrue: [^ self]
					ifFalse: [evt := self generateMouseEvent: evtBuf]].
		type = EventTypeKeyboard 
			ifTrue: [evt := self generateKeyboardEvent: evtBuf].
		type = EventTypeDragDropFiles 
			ifTrue: [evt := self generateDropFilesEvent: evtBuf].
		"All other events are ignored"
		(type ~= EventTypeDragDropFiles and: [evt isNil]) ifTrue: [^self].
		evt isNil ifFalse: [
			"Finally, handle it"
			self handleEvent: evt.
			hadAny := true.

			"For better user feedback, return immediately after a mouse event has been processed."
			(evt isMouse and: [evt isMouseWheel not]) ifTrue: [^self]
		]
	].
	
	"note: if we come here we didn't have any mouse events"
	mouseClickState notNil ifTrue: [
		"No mouse events during this cycle. Make sure click states time out accordingly"
		mouseClickState handleEvent: lastMouseEvent asMouseMove from: self].
	
	hadAny ifFalse: [
		"No pending events. Make sure z-order is up to date"
		self mouseOverHandler processMouseOver: lastMouseEvent]! !

HandMorph subclass: #MultiPointerHandMorph
	instanceVariableNames: 'queue lastPosition buttons mouseID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/29/2009 17:49'!
buttons

	^ buttons! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/29/2009 17:50'!
buttons: newButtons

	buttons := newButtons! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/29/2009 17:52'!
createMorphicButtonEvents: aState

	| result |
	result := OrderedCollection new.
	0 to: 2 do: [:each |
		(aState buttons anyMask: (1 bitShift: each*2)) ifTrue: [
			self buttons: (self buttons bitOr: (1 bitShift: (2-each))).
			result add: (MouseButtonEvent new 
				setType: #mouseDown
				position: self lastPosition
				which: (1 bitShift: (2-each))
				buttons: self buttons
				hand: self
				stamp: Time millisecondClockValue)].
		(aState buttons anyMask: (1 bitShift: (each*2)+1)) ifTrue: [
			self buttons: (self buttons bitAnd: ((1 bitShift: (2-each)) bitInvert)).
			result add: (MouseButtonEvent new 
				setType: #mouseUp
				position: self lastPosition
				which: (1 bitShift: (2-each))
				buttons: self buttons
				hand: self
				stamp: Time millisecondClockValue)].
	].
	^ result! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/29/2009 17:53'!
createMorphicMoveEvent: aState

	| newPosition evt tempPoint |
	tempPoint := Point x: aState x y: aState y.
	newPosition := self lastPosition + tempPoint.
	newPosition := newPosition adhereTo: Display fullBoundingBox.
	evt := MouseMoveEvent new
		setType: #mouseMove
		startPoint: self lastPosition
		endPoint: newPosition
		trail: nil
		buttons: self buttons
		hand: self
		stamp: Time millisecondClockValue.
	self lastPosition: newPosition.
	^ evt! !

!MultiPointerHandMorph methodsFor: 'event handling' stamp: 'SR 4/29/2009 17:26'!
enqueueEvent: aState

	self queue nextPut: (self createMorphicMoveEvent: aState).
	
	aState buttons isZero ifFalse: [
		self queue nextPutAll: (self createMorphicButtonEvents: aState)]! !

!MultiPointerHandMorph methodsFor: 'initialization' stamp: 'SR 4/29/2009 17:53'!
initialize

	super initialize.
	self queue: SharedQueue new.
	self lastPosition: 0 asPoint.
	self buttons: 0.
! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
lastPosition

	^ lastPosition! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
lastPosition: anObject

	lastPosition := anObject! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:32'!
mouseID

	^ mouseID! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 14:32'!
mouseID: anObject

	mouseID := anObject! !

!MultiPointerHandMorph methodsFor: 'drawing' stamp: 'SR 4/24/2009 13:39'!
needsToBeDrawn

	^ true! !

!MultiPointerHandMorph methodsFor: 'event handling' stamp: 'SR 4/24/2009 13:43'!
processEvents
	"Play back the next event"

	[self queue isEmpty] whileFalse: [
		self handleEvent: self queue next].! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
queue

	^ queue! !

!MultiPointerHandMorph methodsFor: 'accessing' stamp: 'SR 4/24/2009 13:38'!
queue: anObject

	queue := anObject! !

!SharedQueue methodsFor: '*xpf-multipoint' stamp: 'SR 4/29/2009 17:24'!
nextPutAll: aCollection

	aCollection do: [:each | self nextPut: each].! !

SmartSyntaxInterpreterPlugin subclass: #MultiPointerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:07'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^ true! !

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:08'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^ true! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
initialiseModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerInit()' inSmalltalk:[true]! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 13:23'!
moduleUnloaded: aModuleName 
	"The module with the given name was just unloaded. 
	Make sure we have no dangling references."
	self export: true.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/22/2009 14:28'!
primitiveMultiPointerCount

	| r |
	self primitive: 'primitiveMultiPointerCount'.
	r := self cCode:' multiPointerCount()'.
	^r asOop: SmallInteger! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/28/2009 21:23'!
primitiveMultiPointerCurrentPoint: aPointerID

	| oop inputX inputY |
	self primitive:'primitiveMultiPointerCurrentPoint'.
	self var: 'inputX' declareC: 'int inputX'.
	self var: 'inputY' declareC: 'int inputY'.
	self cCode: 'multiPointerCurrentPoint(interpreterProxy->integerValueOf(aPointerID), &inputX, &inputY)'.
	oop := interpreterProxy makePointwithxValue: inputX yValue: inputY.
	^ oop! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/29/2009 16:40'!
primitiveMultiPointerCurrentState: aPointerID with: aMultiPointerState

	|  inputX inputY buttons |
	self primitive:'primitiveMultiPointerCurrentState'.
	self var: #inputX declareC: 'int inputX'.
	self var: #inputY declareC: 'int inputY'.
	self var: #buttons declareC: 'int buttons'.
	self cCode: 'multiPointerCurrentState(interpreterProxy->integerValueOf(aPointerID), &inputX, &inputY, &buttons)'.
	interpreterProxy storeInteger: 0 ofObject: aMultiPointerState withValue: inputX.
	interpreterProxy storeInteger: 1 ofObject: aMultiPointerState withValue: inputY.
	interpreterProxy storeInteger: 2 ofObject: aMultiPointerState withValue: buttons.
	^ aMultiPointerState! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/29/2009 19:12'!
primitiveMultiPointerDeviceSemaphoreHandle: aSemaIndex

	| |
	self primitive:'primitiveMultiPointerDeviceSemaphoreHandle' parameters: #(#SmallInteger).
	self multiPointerSetDeviceSemaphore: aSemaIndex.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/29/2009 19:11'!
primitiveMultiPointerEventSemaphoreHandle: aSemaIndex

	| |
	self primitive:'primitiveMultiPointerEventSemaphoreHandle' parameters: #(#SmallInteger).
	self multiPointerSetEventSemaphore: aSemaIndex.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/29/2009 13:59'!
primitiveMultiPointerLively: aPointerID

	| result |
	self primitive:'primitiveMultiPointerLively'.
	result := self multiPointerLively: (interpreterProxy integerValueOf: aPointerID).
	^result asOop: SmallInteger! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/29/2009 11:55'!
primitiveMultiPointerName: aPointerID

	| oop length buffer |
	self primitive:'primitiveMultiPointerName'.
	length := self multiPointerNameLength:  (interpreterProxy integerValueOf: aPointerID).
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length.
	buffer :=  interpreterProxy firstIndexableField: oop.
	self cCode: 'multiPointerName(interpreterProxy->integerValueOf(aPointerID), length, buffer)'.
	^ oop! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
shutdownModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerShutdown()' inSmalltalk:[true]! !
MultiPointerManager initialize!
